// 提出需求
<template>
  <div class="inwardRequirement">
    <div class="sache">
      <el-input placeholder="请输入内容" v-model="inputText" clearable>
      </el-input>
      <span>需求时间：</span>
      <el-date-picker
        v-model="startTime"
        type="datetime"
        placeholder="选择日期"
        style="width:220px"
      >
      </el-date-picker>
      <span>至</span>
      <el-date-picker
        v-model="endTime"
        type="datetime"
        placeholder="选择日期"
        style="width:220px"
      >
      </el-date-picker>
      <el-button type="primary" class="btn" @click="onclick">
        <i class="el-icon-search"></i>查询
      </el-button>
      <el-button
        type="primary"
        class="btn"
        @click="toInsert2"
        v-if="activeName == 'first'"
      >
        <i class="el-icon-plus"></i>新增
      </el-button>
      <el-button
        type="primary"
        class="btn"
        @click="Issue"
        v-if="activeName == 'first'"
      >
        <i class="el-icon-download"></i>下发
      </el-button>
    </div>
    <template>
      <div>
        <el-tabs v-model="activeName" @tab-click="handleClick">
          <el-tab-pane label="未下发" name="first">
            <dilTable
              v-bind.sync="first"
              @selection-change="selectionChange"
              ref="table1"
            >
              <el-table-column fixed="right" label="操作" width="90">
                <template slot-scope="scope">
                  <el-button
                    type="text"
                    size="mini"
                    @click="deleteRequirement(scope)"
                  >
                    删除
                  </el-button>
                </template>
              </el-table-column>
            </dilTable>
          </el-tab-pane>
          <el-tab-pane label="已下发" name="second">
            <dilTable v-bind.sync="second" ref="table">
              <el-table-column fixed="right" label="操作" width="80">
                <template slot-scope="scope">
                  <el-button
                    type="text"
                    size="mini"
                    @click="getRequirementOrder(scope)"
                    >运单</el-button
                  >
                </template>
              </el-table-column>
            </dilTable>
          </el-tab-pane>
        </el-tabs>
      </div>
    </template>
  </div>
</template>
<script>
import { getCookie } from "@/utils/util.js";
import { sjTime } from "@/utils/sharedJsFile";
export default {
  data() {
    return {
      inputText: null,
      orgCode: null,
      endTime: null,
      startTime: null,
      first: {
        // first请求数据的地址
        requestUrl: "",
        selectionType: "select",
        mapList: []
      },
      second: {
        // second请求数据的地址
        requestUrl: ""
      },
      tableData: [],
      tableData1: [
        {
          materialCount: 100
        }
      ],
      activeName: "first"
    };
  },
  created() {
    if (
      getCookie("orgCode") == "dagangadmin" ||
      getCookie("orgCode") == "zidonghuabu"
    ) {
      this.first.requestUrl =
        "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=0";
      this.second.requestUrl =
        "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=1";
    } else {
      this.first.requestUrl =
        "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=0&orgCode=" +
        getCookie("orgCode");
      this.second.requestUrl =
        "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=1&orgCode=" +
        getCookie("orgCode");
    }
  },
  methods: {
    onclick() {
      let orgCode = null;
      let startTime = null;
      let endTime = null;
      if (this.startTime && this.endTime) {
        startTime = sjTime(this.startTime);
        endTime = sjTime(this.endTime);
      }
      if (
        getCookie("orgCode") != "dagangadmin" &&
        getCookie("orgCode") != "zidonghuabu"
      ) {
        orgCode = getCookie("orgCode");
      }
      if (this.activeName == "first") {
        this.first.requestUrl =
          "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=0&orgCode=" +
          orgCode +
          "&index=" +
          this.inputText +
          "&startTime=" +
          startTime +
          "&endTime=" +
          endTime +
          "&i=" +
          new Date();
      } else {
        this.second.requestUrl =
          "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=1&orgCode=" +
          orgCode +
          "&index=" +
          this.inputText +
          "&startTime=" +
          startTime +
          "&endTime=" +
          endTime +
          "&i=" +
          new Date();
      }
    },
    //查看需求下面的运单
    getRequirementOrder(scope) {
      this.$router.push("/getRequirementOrder/" + scope.row.requirementId);
    },
    handleClick(tab, event) {
      this.getRequestUrl();
    },
    getRequestUrl() {
      if (
        getCookie("orgCode") == "dagangadmin" ||
        getCookie("orgCode") == "zidonghuabu"
      ) {
        this.first.requestUrl =
          "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=0&i=" +
          new Date();
        this.second.requestUrl =
          "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=1&i=" +
          new Date();
      } else {
        this.first.requestUrl =
          "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=0&orgCode=" +
          getCookie("orgCode") +
          "&i=" +
          new Date();
        this.second.requestUrl =
          "/api/v1/ams/getTruckRequirementList?apiId=207&requirementStatus=1&orgCode=" +
          getCookie("orgCode") +
          "&i=" +
          new Date();
      }
    },
    selectionChange(selection) {
      this.first.mapList = selection;
    },
    toInsert2() {
      this.$router.push("/addRequirement2");
    },
    updateRequirement(scope) {
      this.$router.push("/updateRequirement/" + scope.row.requirementId);
    },
    deleteRequirement(scope) {
      this.$confirm("是否删除", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
        center: true
      })
        .then(() => {
          this.axios
            .post(
              "/api/v1/ams/deleteTruckRequirement/" + scope.row.requirementId
            )
            .then(res => {
              if (res.data.code == 200) {
                this.$message({
                  type: "success",
                  message: "删除成功!"
                });
                this.getRequestUrl();
              } else {
                this.$message({
                  message: "删除失败",
                  type: "warning"
                });
              }
            });
        })
        .catch(() => {
          this.$message({
            type: "info",
            message: "删除操作已取消!"
          });
        });
    },
    Issue() {
      console.log(this.first.mapList);
      if (this.first.mapList.length == 0) {
        this.$message.warning("请选择需求");
        return;
      }
      // 权限控制，判断用户是否属于炼铁厂下面的车间
      for (let i = 0; i < this.first.mapList.length; i++) {
        if (
          this.first.mapList[i].requirementType == "计时" &&
          (getCookie("orgCode") == "liantiechang-yuanliaochejian" ||
            getCookie("orgCode") == "liantiechang-shaojiechejian" ||
            getCookie("orgCode") == "liantiechang-dagaoluchejian" ||
            getCookie("orgCode") == "liantiechang-xiaogaoluchejian" ||
            getCookie("orgCode") == "liantiechang-rongjichejian" ||
            getCookie("orgCode") == "liantiechang-weijianchejian")
        ) {
          this.$message.warning("请选择联系炼铁厂相关负责人完成计时作业下发");
          return;
        }
      }
      this.$confirm("是否下发", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
        center: true
      })
        .then(() => {
          this.axios
            .post("/api/v1/ams/downRequirement", this.first.mapList)
            .then(res => {
              if (res.data.code == 200) {
                this.$message({
                  type: "success",
                  message: "下发成功!"
                });
                this.getRequestUrl();
                this.activeName = "second";
              } else {
                this.$message({
                  message: "下发失败",
                  type: "warning"
                });
              }
            });
        })
        .catch(() => {
          this.$message({
            type: "info",
            message: "取消下发!"
          });
        });
    }
  }
};
</script>
<style lang="scss" scoped>
.inwardRequirement {
  margin-top: 20px;
  margin-left: 20px;
  .sache {
    margin-top: 30px;
    padding-bottom: 10px;
    .el-input {
      width: 20%;
    }
  }
}
</style>
